'######################################################################
'# Firmware fr Sparmatic Zero                                        #
'#                                                                    #
'# Verwendung auf eigene Gefahr! Die Schaltung enthlt eine H-Brcke. #
'# PortG.3 und PortG.4 drfen niemals gleichzeitig 1 sein, da sonst   #
'# ein Kurzschluss entsteht, der Beschdigungen zur Folge haben kann! #
'# Ich bernehme keine Haftung.                                       #
'#                                                                    #
'# 09.11.2009 T.Fischer                                               #
'######################################################################

$regfile = "m169def.dat"                                    ' specify the used micro
$crystal = 1000000                                          ' used crystal frequency
$hwstack = 32                                               ' default use 32 for the hardware stack
$swstack = 10                                               ' default use 10 for the SW stack
$framesize = 40                                             ' default use 40 for the frame space
Config Clock = Soft , Gosub = Sectic

' Nuttenvariablen
Dim I As Byte
Dim J As Byte
Dim K As Byte
Dim L As Byte
Dim W As Word

'Config fr Temperatursensor
Config Adc = Single , Prescaler = Auto , Reference = Avcc
Config Portf.2 = Output
Dim Ist_temperatur As Single
Dim Adc_temp(10) As Word
Adc_temp(1) = 757                                           '0C
Adc_temp(2) = 703                                           '5C
Adc_temp(3) = 645                                           '10C
Adc_temp(4) = 585                                           '15C
Adc_temp(5) = 525                                           '20C
Adc_temp(6) = 465                                           '25C
Adc_temp(7) = 409                                           '30C
Adc_temp(8) = 356                                           '35C
Adc_temp(9) = 308                                           '40C
Adc_temp(10) = 266                                          '45C

'Config fr LCD
Declare Sub Lcd_balken(wert As Byte)
Declare Sub Lcd_writetext
Dim Text As String * 5
Dim Textchar(5) As Byte At Text Overlay
Lcdcrb = &B10110101                                         ' 32767Hc Osc., Bias 1/3, Duty 1/3, PortMask SEG0...SEG22
Lcdfrr = &B00000110                                         ' Prescale 32767/16/7=49Hc LCD clock rate
Lcdccr = &B00001110                                         ' LCD Power 3.3 V (Contrast)
Lcdcra = &B10000000                                         ' LCD on
Skala Alias Lcddr0.0                                        'LCD Aliase
Auto Alias Lcddr5.1
Manu Alias Lcddr10.2
Prog Alias Lcddr5.2
Batterie Alias Lcddr10.1
Sonne Alias Lcddr7.4
Mond Alias Lcddr12.4
Frost Alias Lcddr7.3
Funk Alias Lcddr12.3



'Main Loop
Do

Loop


'############################
'# Es folgen die Interrupts #
'############################

Sectic:                                                     'jede sekunde
      Set Portf.2                                           'Temperatur messen
      Start Adc
      W = Getadc(0)
      Reset Portf.2
      Stop Adc
      I = 1
      Do
         J = Adc_temp(i)
         Incr I
         K = Adc_temp(i)
      Loop Until W > Adc_temp(i)
      I = I * 5
      I = I - 5
      J = J - K
      L = W - K
      Ist_temperatur = 5 / J                                '1-2% Flash!!! 'vorher mit x multiplizieren und dann Ganzzahldivision?
      Ist_temperatur = Ist_temperatur * L                   '1-2% Flash!!! 'Oder  5/60=0,08333 fix
      Ist_temperatur = I - Ist_temperatur                   '1-2% Flash!!!
      Text = Fusing(ist_temperatur , "#.#")                 '4-5% Flash!!! 'Ausgabe vereinfachen
      Textchar(5) = 167
      Call Lcd_writetext
   
Return


'#######################
'# Es folgen die Sub's #
'#######################
Sub Lcd_balken(wert As Byte)
   Lcddr0 = 0                                               'Balken lschen
   Lcddr1 = 0
   Lcddr2 = Lcddr2 And &B11100000
   Lcddr10.5 = 0
   Lcddr11.5 = 0
   Lcddr12.1 = 0
   For I = 1 To Wert                                        'Balken aufbauen
      Select Case I
         Case 1 To 7 : Set Lcddr0.i
         Case 8 To 10 : K = I - 8
                        Set Lcddr1.k
         Case 11 : Set Lcddr11.1
         Case 12 : Set Lcddr10.5
         Case 13 : Set Lcddr12.1
         Case 14 : Set Lcddr11.5
         Case 15 To 19 : K = I - 12
                        Set Lcddr1.k
         Case 20 To 24 : K = I - 20
                        Set Lcddr2.k
      End Select
   Next I
End Sub

Sub Lcd_writetext
   Lcddr5 = Lcddr5 And &B00000110                           'Clear Textsegmente
   Lcddr6 = &B00000000
   Lcddr7 = Lcddr7 And &B11111000
   Lcddr10 = Lcddr10 And &B10100110
   Lcddr11 = Lcddr11 And &B00100010
   Lcddr12 = Lcddr12 And &B11111010
   If Textchar(3) = 58 Or Textchar(3) = 59 Then             'Doppelpunkt rausfiltern und ggf anzeigen
         Set Lcddr5.0
         Set Lcddr10.0
         Textchar(3) = Textchar(4)
         Textchar(4) = Textchar(5)
   End If
   If Textchar(3) = 44 Or Textchar(3) = 46 Then             '   Punkt rausfiltern und ggf anzeigen
         Set Lcddr10.0
         Textchar(3) = Textchar(4)
         Textchar(4) = Textchar(5)
   End If

   'i:stelle, j:bitmuster, k:"upper-nibble", l:"lower nibble"
   For I = 1 To 4
      Select Case Textchar(i)                               'Bitmuster laden
         Case 48 : J = &B11011011                           '0
         Case 49 : J = &B10001000                           '1
         Case 50 : J = &B11100011
         Case 51 : J = &B11101010
         Case 52 : J = &B10111000
         Case 53 : J = &B01111010
         Case 54 : J = &B01111011
         Case 55 : J = &B11001000
         Case 56 : J = &B11111011
         Case 57 : J = &B11111010                           '9
         Case 167 : J = &B11110000                          '
         Case Else : J = &B00000000                         'space
      End Select

      If I.0 = 1 Then                                       'ungrade
         K = J And &B11110000                               'lcddr5 (stelle1) bzw lcddr6(stelle3)
         Shift K , Right , 1
         L = J And &B00001111                               'lcddr10(stelle1) bzw lcddr11(stelle3)
         Shift L , Left , 3
         If I = 1 Then                                      'i=1
            Lcddr5 = Lcddr5 Or K
            Lcddr10 = Lcddr10 Or L
            Else                                            'i=3
            Lcddr6 = Lcddr6 Or K
            Lcddr11 = Lcddr11 Or L
         End If
      Else                                                  'grade
         K = J And &B11100000                               'lcddr6(stelle2) bzw lcddr7(stelle4)
         Shift K , Right , 5
         L = J And &B00001110                               'lcddr11(stelle2) bzw lcddr12(stelle4)
         Shift L , Right , 1
         If I = 2 Then                                      'i=2
            Lcddr5.7 = J.4
            Lcddr6 = Lcddr6 Or K
            Lcddr10.7 = J.0
            Lcddr11 = Lcddr11 Or L
            Else                                            'i=4
            Lcddr6.7 = J.4
            Lcddr7 = Lcddr7 Or K
            Lcddr11.7 = J.0
            Lcddr12 = Lcddr12 Or L
         End If
      End If
   Next I
End Sub